Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Axiom match_nat_prop : forall (return_:(nat -> Prop)), (return_ O) -> (forall (n:nat), return_ (S n)) -> forall (z:nat), return_ z.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Definition sym_eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) case_O (match_nat_type (return_type) case_O case_S O) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Definition pred : nat -> nat := fun (n:nat) => match_nat_type (nat) O (fun (p:nat) => p) n.
Definition not_zero : nat -> Prop := fun (n:nat) => match_nat_type (Prop) connectives.False (fun (p:nat) => connectives.True) n.
Parameter le : nat -> nat -> Prop.
Axiom le_n : forall (n:nat), le n n.
Axiom le_S : forall (n:nat), forall (m:nat), (le n m) -> le n (S m).
Axiom le_ind : forall (n:nat), forall (Q:(nat -> Prop)), (Q n) -> (forall (m:nat), (le n m) -> (Q m) -> Q (S m)) -> forall (m:nat), (le n m) -> Q m.
Definition lt : nat -> nat -> Prop := fun (n:nat) => fun (m:nat) => le (S n) m.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Axiom axiom_plus_body_S : forall (n:nat), connectives.equal (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)).
Definition eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((axiom_plus_body_S) (n)).
Definition sym_eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => S (plus n m)) (plus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((eq_plus_body_S) (n)).
Definition nat_elim2 : forall (R:(nat -> nat -> Prop)), (forall (n:nat), R O n) -> (forall (n:nat), R (S n) O) -> (forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) -> forall (n:nat), forall (m:nat), R n m := fun (R:nat -> nat -> Prop) => fun (ROn:forall (n:nat), R O n) => (fun (RSO:forall (n:nat), R (S n) O) => (fun (RSS:forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) => (fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), R _x_365 m)) (fun (m:nat) => (ROn) (m))) (fun (n0:nat) => fun (Rn0m:forall (m:nat), R n0 m) => (fun (m:nat) => ((((match_nat_prop) (fun (__:nat) => R (S n0) __)) ((RSO) (n0))) (fun (auto:nat) => (((RSS) (n0)) (auto)) ((Rn0m) (auto)))) (m)))) (n)))).
Definition pred_Sn : forall (n:nat), logic.eq (nat) n (pred (S n)) := fun (n:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (n)) (fun (y:nat) => logic.eq (nat) n y)) (((logic.refl) (nat)) (n)).
Definition plus_O_n : forall (n:nat), logic.eq (nat) n (plus O n) := fun (n:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((logic.refl) (nat)) (n)))).
Definition plus_n_O : forall (n:nat), logic.eq (nat) n (plus n O) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (nat) _x_365 (plus _x_365 O))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((logic.refl) (nat)) (O)))))) (fun (x_366:nat) => fun (_x_368:logic.eq (nat) x_366 (plus x_366 O)) => ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) (((((((logic.rewrite_l) (nat)) (x_366)) (fun (__:nat) => logic.eq (nat) (S x_366) (S __))) (((logic.refl) (nat)) (S x_366))) (plus x_366 O)) (_x_368))))))) (n).
Definition plus_n_Sm : forall (n:nat), forall (m:nat), logic.eq (nat) (S (plus n m)) (plus n (S m)) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), logic.eq (nat) (S (plus _x_365 m)) (plus _x_365 (S m)))) (fun (m:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus O (S m)))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S m) (y (S m)))) (((logic.refl) (nat)) (S m))))))))) (fun (x_366:nat) => fun (_x_368:forall (m:nat), logic.eq (nat) (S (plus x_366 m)) (plus x_366 (S m))) => (fun (m:nat) => (((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus (S x_366) (S m)))) ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (S (plus x_366 m))) (y (S m)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S m))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) __ (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) (plus x_366 (S (S m))) __)) (((logic.refl) (nat)) (plus x_366 (S (S m))))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 m))) ((_x_368) (m))))))))))) (n).
Definition commutative_plus : relations.commutative (nat) plus := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), logic.eq (nat) (plus _x_365 y) (plus y _x_365))) (fun (y:nat) => (((sym_eq_plus) (O)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((sym_eq_plus_body_O) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((((((logic.rewrite_l) (nat)) (y)) (fun (__:nat) => logic.eq (nat) y __)) (((logic.refl) (nat)) (y))) (plus y O)) ((plus_n_O) (y))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), logic.eq (nat) (plus x_366 y) (plus y x_366)) => (fun (y:nat) => (((sym_eq_plus) (S x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) ((((sym_eq_plus_body_S) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S y))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus y (S x_366))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((logic.refl) (nat)) (plus y (S x_366)))) (plus x_366 (S y))) (((((((logic.rewrite_l) (nat)) (S (plus x_366 y))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus y x_366)) (fun (__:nat) => logic.eq (nat) (S __) (plus y (S x_366)))) (((plus_n_Sm) (y)) (x_366))) (plus x_366 y)) ((_x_368) (y)))) (plus x_366 (S y))) (((plus_n_Sm) (x_366)) (y))))) (S (plus x_366 y))) (((plus_n_Sm) (x_366)) (y)))))))) (n).
Definition lt_to_not_zero : forall (n:nat), forall (m:nat), (lt n m) -> not_zero m := fun (n:nat) => fun (m:nat) => fun (Hlt:lt n m) => (((((((le_ind) (S n)) (fun (x_417:nat) => not_zero x_417)) (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (n)) (fun (y:Prop) => y)) (connectives.I))) (fun (m0:nat) => fun (_x_419:le (S n) m0) => (fun (_x_421:not_zero m0) => (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (m0)) (fun (y:Prop) => y)) (connectives.I))))) (m)) (Hlt)).
Definition le_S_S : forall (n:nat), forall (m:nat), (le n m) -> le (S n) (S m) := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (S n) (S x_417))) ((le_n) (S n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (S n) (S m0)) => ((((le_S) (S n)) (S m0)) (_x_421))))) (m)) (lenm)).
Definition le_O_n : forall (n:nat), le O n := fun (n:nat) => ((((nat_ind) (le O)) ((le_n) (O))) (fun (x_366:nat) => fun (_x_368:le O x_366) => ((((le_S) (O)) (x_366)) (_x_368)))) (n).
Definition le_n_Sn : forall (n:nat), le n (S n) := fun (n:nat) => (((le_S) (n)) (n)) ((le_n) (n)).
Definition transitive_le : relations.transitive (nat) le := fun (a:nat) => fun (b:nat) => fun (c:nat) => fun (leab:le a b) => (fun (lebc:le b c) => (((((((le_ind) (b)) (fun (x_417:nat) => le a x_417)) (leab)) (fun (m:nat) => fun (_x_419:le b m) => (fun (_x_421:le a m) => ((((le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
Definition le_pred_n : forall (n:nat), le (pred n) n := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => le (pred _x_365) _x_365)) ((((((eq_match_nat_type_O) (nat)) (O)) (fun (p:nat) => p)) (fun (y:nat) => le (match_nat_type (nat) O (fun (p:nat) => p) O) y)) ((le_n) (pred O)))) (fun (x_366:nat) => fun (_x_368:le (pred x_366) x_366) => (((((((eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (x_366)) (fun (y:nat) => le (pred (S x_366)) (S y))) ((le_n_Sn) (pred (S x_366)))))) (n).
Definition monotonic_pred : relations.monotonic (nat) le pred := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (pred n) (pred x_417))) ((le_n) (pred n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (pred n) (pred m0)) => ((((((transitive_le) (pred n)) (n)) (pred (S m0))) ((le_pred_n) (n))) (((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (m0)) (fun (y:nat) => le n y)) (_x_419)))))) (m)) (lenm)).
Definition monotonic_le_plus_r : forall (n:nat), relations.monotonic (nat) le (fun (m:nat) => plus n m) := fun (n:nat) => fun (a:nat) => fun (b:nat) => ((((nat_ind) (fun (_x_365:nat) => (le a b) -> le (plus _x_365 a) (plus _x_365 b))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le a b) -> le (plus O a) (y b))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le a b) -> le (y a) (filter_nat_type (nat -> nat) plus_body O b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le a b) -> le (y a) (filter_nat_type (nat -> nat) plus_body O b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le a b) -> le (plus_body O a) (y b))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le a b) -> le (plus_body O a) (y b))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le a b) -> le (y a) b)) (fun (auto:le a b) => (auto))))))))) (fun (m:nat) => fun (H:(le a b) -> le (plus m a) (plus m b)) => (fun (leab:le a b) => ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => le (plus (S m) a) (y b))) ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => le (y a) (filter_nat_type (nat -> nat) plus_body (S m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => le (y a) (filter_nat_type (nat -> nat) plus_body (S m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => le (plus_body (S m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => le (plus_body (S m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => le (y a) (S (plus m b)))) ((((le_S_S) (plus m a)) (plus m b)) ((H) (leab)))))))))))) (n).
Definition monotonic_le_plus_l : forall (m:nat), relations.monotonic (nat) le (fun (n:nat) => plus n m) := fun (m:nat) => fun (x:nat) => fun (y:nat) => fun (auto:le x y) => (((((logic.eq_coerc) (le (plus m x) (plus m y))) (le (plus x m) (plus y m))) (((((monotonic_le_plus_r) (m)) (x)) (y)) (auto))) (((((((logic.rewrite_r) (nat)) (plus m x)) (fun (__:nat) => logic.eq (Prop) (le (plus m x) (plus m y)) (le __ (plus y m)))) (((((((logic.rewrite_r) (nat)) (plus m y)) (fun (__:nat) => logic.eq (Prop) (le (plus m x) (plus m y)) (le (plus m x) __))) (((logic.refl) (Prop)) (le (plus m x) (plus m y)))) (plus y m)) (((commutative_plus) (y)) (m)))) (plus x m)) (((commutative_plus) (x)) (m)))).
Definition le_plus_n : forall (n:nat), forall (m:nat), le m (plus n m) := fun (n:nat) => fun (m:nat) => ((((logic.eq_coerc) (le (plus O m) (plus n m))) (le m (plus n m))) (((((monotonic_le_plus_l) (m)) (O)) (n)) ((le_O_n) (n)))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le __ (plus n m)) (le m (plus n m)))) (((logic.refl) (Prop)) (le m (plus n m)))) (plus O m)) ((plus_O_n) (m))).
Definition le_plus_b : forall (b:nat), forall (n:nat), forall (m:nat), (le (plus n b) m) -> le n m := fun (b:nat) => fun (n:nat) => fun (m:nat) => fun (auto:le (plus n b) m) => ((((((transitive_le) (n)) (plus n b)) (m)) (((((logic.eq_coerc) (le n (plus b n))) (le n (plus n b))) (((le_plus_n) (b)) (n))) (((((((logic.rewrite_r) (nat)) (plus b n)) (fun (__:nat) => logic.eq (Prop) (le n (plus b n)) (le n __))) (((logic.refl) (Prop)) (le n (plus b n)))) (plus n b)) (((commutative_plus) (n)) (b))))) (auto)).
Definition lt_to_le : forall (x:nat), forall (y:nat), (lt x y) -> le x y := fun (x:nat) => fun (y:nat) => fun (auto:lt x y) => (((((le_plus_b) (S O)) (x)) (y)) (((((logic.eq_coerc) (le (S x) y)) (le (plus x (S O)) y)) (auto)) (((((((logic.rewrite_r) (nat)) (plus x (S O))) (fun (__:nat) => logic.eq (Prop) (le __ y) (le (plus x (S O)) y))) (((logic.refl) (Prop)) (le (plus x (S O)) y))) (S x)) (((((((logic.rewrite_r) (nat)) (plus x O)) (fun (__:nat) => logic.eq (nat) (S __) (plus x (S O)))) (((plus_n_Sm) (x)) (O))) (x)) ((plus_n_O) (x)))))).
Definition transitive_lt : relations.transitive (nat) lt := fun (a:nat) => fun (b:nat) => fun (c:nat) => fun (ltab:lt a b) => (fun (ltbc:lt b c) => (((((((le_ind) (S b)) (fun (x_417:nat) => lt a x_417)) ((((le_S) (S a)) (b)) (ltab))) (fun (m:nat) => fun (_x_419:le (S b) m) => (fun (_x_421:lt a m) => ((((le_S) (S a)) (m)) (_x_421))))) (c)) (ltbc))).
Definition lt_to_le_to_lt : forall (n:nat), forall (m:nat), forall (p:nat), (lt n m) -> (le m p) -> lt n p := fun (n:nat) => fun (m:nat) => fun (p:nat) => fun (H:lt n m) => (fun (H1:le m p) => (((((((le_ind) (m)) (fun (x_417:nat) => lt n x_417)) (H)) (fun (m0:nat) => fun (_x_419:le m m0) => (fun (_x_421:lt n m0) => ((((((transitive_lt) (n)) (m0)) (S m0)) (_x_421)) (((((logic.eq_coerc) (le (S m0) (plus O (S m0)))) (le (S m0) (S m0))) (((le_plus_n) (O)) (S m0))) (((((((logic.rewrite_l) (nat)) (S m0)) (fun (__:nat) => logic.eq (Prop) (le (S m0) __) (le (S m0) (S m0)))) (((logic.refl) (Prop)) (le (S m0) (S m0)))) (plus O (S m0))) ((plus_O_n) (S m0)))))))) (p)) (H1))).
Definition le_to_lt_to_lt : forall (n:nat), forall (m:nat), forall (p:nat), (le n m) -> (lt m p) -> lt n p := fun (n:nat) => fun (m:nat) => fun (p:nat) => fun (H:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => (lt x_417 p) -> lt n p)) (fun (auto:lt n p) => (auto))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:(lt m0 p) -> lt n p) => (fun (auto:lt (S m0) p) => ((_x_421) ((((((transitive_lt) (m0)) (S m0)) (p)) (((((logic.eq_coerc) (le (S m0) (plus O (S m0)))) (le (S m0) (S m0))) (((le_plus_n) (O)) (S m0))) (((((((logic.rewrite_l) (nat)) (S m0)) (fun (__:nat) => logic.eq (Prop) (le (S m0) __) (le (S m0) (S m0)))) (((logic.refl) (Prop)) (le (S m0) (S m0)))) (plus O (S m0))) ((plus_O_n) (S m0))))) (auto))))))) (m)) (H)).
Definition ltn_to_ltO : forall (n:nat), forall (m:nat), (lt n m) -> lt O m := fun (n:nat) => fun (m:nat) => fun (auto:lt n m) => ((((((lt_to_le_to_lt) (O)) (S n)) (m)) (((((logic.eq_coerc) (le (S O) (plus n (S O)))) (le (S O) (S n))) (((le_plus_n) (n)) (S O))) (((((((logic.rewrite_l) (nat)) (S n)) (fun (__:nat) => logic.eq (Prop) (le (S O) __) (le (S O) (S n)))) (((logic.refl) (Prop)) (le (S O) (S n)))) (plus n (S O))) (((((((logic.rewrite_r) (nat)) (plus n O)) (fun (__:nat) => logic.eq (nat) (S __) (plus n (S O)))) (((plus_n_Sm) (n)) (O))) (n)) ((plus_n_O) (n)))))) (auto)).
Definition lt_O_S : forall (n:nat), lt O (S n) := fun (n:nat) => (((ltn_to_ltO) (n)) (S n)) (((((logic.eq_coerc) (le (S n) (plus O (S n)))) (le (S n) (S n))) (((le_plus_n) (O)) (S n))) (((((((logic.rewrite_l) (nat)) (S n)) (fun (__:nat) => logic.eq (Prop) (le (S n) __) (le (S n) (S n)))) (((logic.refl) (Prop)) (le (S n) (S n)))) (plus O (S n))) ((plus_O_n) (S n)))).
Definition not_le_Sn_O : forall (n:nat), connectives.Not (le (S n) O) := fun (n:nat) => ((connectives.nmk) (le (S n) O)) (fun (Hlen0:le (S n) O) => ((((((eq_match_nat_type_O) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (fun (y:Prop) => y)) ((((lt_to_not_zero) (n)) (O)) (Hlen0)))).
Definition not_le_to_not_le_S_S : forall (n:nat), forall (m:nat), (connectives.Not (le n m)) -> connectives.Not (le (S n) (S m)) := fun (n:nat) => fun (m:nat) => fun (auto:connectives.Not (le n m)) => (((((logic.not_to_not) (le (S n) (S m))) (le n m)) (fun (auto':le (S n) (S m)) => (((((logic.eq_coerc) (le (pred (S n)) (pred (S m)))) (le n m)) ((((monotonic_pred) (S n)) (S m)) (auto'))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le __ (pred (S m))) (le n m))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le n __) (le n m))) (((logic.refl) (Prop)) (le n m))) (pred (S m))) ((pred_Sn) (m)))) (pred (S n))) ((pred_Sn) (n)))))) (auto)).
Definition not_le_S_S_to_not_le : forall (n:nat), forall (m:nat), (connectives.Not (le (S n) (S m))) -> connectives.Not (le n m) := fun (n:nat) => fun (m:nat) => fun (auto:connectives.Not (le (S n) (S m))) => (((((logic.not_to_not) (le n m)) (le (S n) (S m))) (fun (auto':le n m) => ((((le_S_S) (n)) (m)) (auto')))) (auto)).
Definition not_le_Sn_n : forall (n:nat), connectives.Not (le (S n) n) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => connectives.Not (le (S _x_365) _x_365))) ((not_le_Sn_O) (O))) (fun (x_366:nat) => fun (_x_368:connectives.Not (le (S x_366) x_366)) => ((((not_le_to_not_le_S_S) (S x_366)) (x_366)) (_x_368)))) (n).
Definition lt_to_not_le : forall (n:nat), forall (m:nat), (lt n m) -> connectives.Not (le m n) := fun (n:nat) => fun (m:nat) => fun (Hltnm:lt n m) => (((((((le_ind) (S n)) (fun (x_417:nat) => connectives.Not (le x_417 n))) ((not_le_Sn_n) (n))) (fun (m0:nat) => fun (_x_419:le (S n) m0) => (fun (_x_421:connectives.Not (le m0 n)) => (((((logic.not_to_not) (le (S m0) n)) (le m0 n)) (fun (auto:le (S m0) n) => ((((lt_to_le) (m0)) (n)) (auto)))) (_x_421))))) (m)) (Hltnm)).
Definition not_le_to_lt : forall (n:nat), forall (m:nat), (connectives.Not (le n m)) -> lt m n := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => (connectives.Not (le __ _0)) -> lt _0 __)) (fun (n:nat) => fun (abs:connectives.Not (le O n)) => (((connectives.falsity) (lt n O)) ((((logic.absurd) (le O n)) (((((logic.eq_coerc) (le O (plus n O))) (le O n)) (((le_plus_n) (n)) (O))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le O __) (le O n))) (((logic.refl) (Prop)) (le O n))) (plus n O)) ((plus_n_O) (n))))) (abs))))) (fun (n:nat) => fun (auto:connectives.Not (le (S n) O)) => ((lt_O_S) (n)))) (fun (n:nat) => fun (m:nat) => fun (Hind:(connectives.Not (le n m)) -> lt m n) => (fun (HnotleSS:connectives.Not (le (S n) (S m))) => ((((le_S_S) (S m)) (n)) ((Hind) ((((not_le_S_S_to_not_le) (n)) (m)) (HnotleSS)))))).
Definition le_to_or_lt_eq : forall (n:nat), forall (m:nat), (le n m) -> connectives.Or (lt n m) (logic.eq (nat) n m) := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => connectives.Or (lt n x_417) (logic.eq (nat) n x_417))) ((((relations.RC_reflexive) (nat)) (lt)) (n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:connectives.Or (lt n m0) (logic.eq (nat) n m0)) => ((((connectives.or_introl) (lt n (S m0))) (logic.eq (nat) n (S m0))) ((((((le_to_lt_to_lt) (n)) (m0)) (S m0)) (_x_419)) (((((logic.eq_coerc) (le (S m0) (plus O (S m0)))) (le (S m0) (S m0))) (((le_plus_n) (O)) (S m0))) (((((((logic.rewrite_l) (nat)) (S m0)) (fun (__:nat) => logic.eq (Prop) (le (S m0) __) (le (S m0) (S m0)))) (((logic.refl) (Prop)) (le (S m0) (S m0)))) (plus O (S m0))) ((plus_O_n) (S m0))))))))) (m)) (lenm)).
Parameter leb : nat -> nat -> bool.bool.
Parameter leb_body : nat -> nat -> bool.bool.
Axiom axiom_leb : forall (n:nat), connectives.equal (nat -> bool.bool) (leb n) (filter_nat_type (nat -> bool.bool) leb_body n).
Definition eq_leb : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (leb n) (filter_nat_type (nat -> bool.bool) leb_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> bool.bool)) (leb n)) (filter_nat_type (nat -> bool.bool) leb_body n)) ((axiom_leb) (n)).
Definition sym_eq_leb : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (filter_nat_type (nat -> bool.bool) leb_body n) (leb n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> bool.bool)) (leb n)) (filter_nat_type (nat -> bool.bool) leb_body n)) ((eq_leb) (n)).
Axiom axiom_leb_body_O : connectives.equal (nat -> bool.bool) (leb_body O) (fun (m:nat) => bool.true).
Definition eq_leb_body_O : leibniz.leibniz (nat -> bool.bool) (leb_body O) (fun (m:nat) => bool.true) := ((((connectives.equal_leibniz) (nat -> bool.bool)) (leb_body O)) (fun (m:nat) => bool.true)) (axiom_leb_body_O).
Definition sym_eq_leb_body_O : leibniz.leibniz (nat -> bool.bool) (fun (m:nat) => bool.true) (leb_body O) := ((((leibniz.sym_leibniz) (nat -> bool.bool)) (leb_body O)) (fun (m:nat) => bool.true)) (eq_leb_body_O).
Axiom axiom_leb_body_S : forall (n:nat), connectives.equal (nat -> bool.bool) (leb_body (S n)) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => leb n q) m).
Definition eq_leb_body_S : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (leb_body (S n)) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => leb n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> bool.bool)) (leb_body (S n))) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => leb n q) m)) ((axiom_leb_body_S) (n)).
Definition sym_eq_leb_body_S : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => leb n q) m) (leb_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> bool.bool)) (leb_body (S n))) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => leb n q) m)) ((eq_leb_body_S) (n)).
Definition leb_elim : forall (n:nat), forall (m:nat), forall (P:(bool.bool -> Prop)), ((le n m) -> P bool.true) -> ((connectives.Not (le n m)) -> P bool.false) -> P (leb n m) := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => forall (P:(bool.bool -> Prop)), ((le __ _0) -> P bool.true) -> ((connectives.Not (le __ _0)) -> P bool.false) -> P (leb __ _0))) (fun (n:nat) => (((sym_eq_leb) (O)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((le O n) -> P bool.true) -> ((connectives.Not (le O n)) -> P bool.false) -> P (y n))) (((((sym_eq_filter_nat_type_O) (nat -> bool.bool)) (leb_body)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((le O n) -> P bool.true) -> ((connectives.Not (le O n)) -> P bool.false) -> P (y n))) (((sym_eq_leb_body_O) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((le O n) -> P bool.true) -> ((connectives.Not (le O n)) -> P bool.false) -> P (y n))) (fun (P:bool.bool -> Prop) => fun (auto:(le O n) -> P bool.true) => (fun (auto':(connectives.Not (le O n)) -> P bool.false) => ((auto) ((le_O_n) (n))))))))) (fun (n:nat) => (((sym_eq_leb) (S n)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((le (S n) O) -> P bool.true) -> ((connectives.Not (le (S n) O)) -> P bool.false) -> P (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> bool.bool)) (leb_body)) (n)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((le (S n) O) -> P bool.true) -> ((connectives.Not (le (S n) O)) -> P bool.false) -> P (y O))) ((((sym_eq_leb_body_S) (n)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((le (S n) O) -> P bool.true) -> ((connectives.Not (le (S n) O)) -> P bool.false) -> P (y O))) ((((((sym_eq_match_nat_type_O) (bool.bool)) (bool.false)) (fun (q:nat) => leb n q)) (fun (y:bool.bool) => forall (P:(bool.bool -> Prop)), ((le (S n) O) -> P bool.true) -> ((connectives.Not (le (S n) O)) -> P bool.false) -> P y)) (fun (P:bool.bool -> Prop) => fun (auto:(le (S n) O) -> P bool.true) => (fun (auto':(connectives.Not (le (S n) O)) -> P bool.false) => ((auto') ((not_le_Sn_O) (n)))))))))) (fun (n:nat) => fun (m:nat) => (((sym_eq_leb) (S n)) (fun (y:(nat -> bool.bool)) => (forall (P:(bool.bool -> Prop)), ((le n m) -> P bool.true) -> ((connectives.Not (le n m)) -> P bool.false) -> P (leb n m)) -> forall (P:(bool.bool -> Prop)), ((le (S n) (S m)) -> P bool.true) -> ((connectives.Not (le (S n) (S m))) -> P bool.false) -> P (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> bool.bool)) (leb_body)) (n)) (fun (y:(nat -> bool.bool)) => (forall (P:(bool.bool -> Prop)), ((le n m) -> P bool.true) -> ((connectives.Not (le n m)) -> P bool.false) -> P (leb n m)) -> forall (P:(bool.bool -> Prop)), ((le (S n) (S m)) -> P bool.true) -> ((connectives.Not (le (S n) (S m))) -> P bool.false) -> P (y (S m)))) ((((sym_eq_leb_body_S) (n)) (fun (y:(nat -> bool.bool)) => (forall (P:(bool.bool -> Prop)), ((le n m) -> P bool.true) -> ((connectives.Not (le n m)) -> P bool.false) -> P (leb n m)) -> forall (P:(bool.bool -> Prop)), ((le (S n) (S m)) -> P bool.true) -> ((connectives.Not (le (S n) (S m))) -> P bool.false) -> P (y (S m)))) (((((((sym_eq_match_nat_type_S) (bool.bool)) (bool.false)) (fun (q:nat) => leb n q)) (m)) (fun (y:bool.bool) => (forall (P:(bool.bool -> Prop)), ((le n m) -> P bool.true) -> ((connectives.Not (le n m)) -> P bool.false) -> P (leb n m)) -> forall (P:(bool.bool -> Prop)), ((le (S n) (S m)) -> P bool.true) -> ((connectives.Not (le (S n) (S m))) -> P bool.false) -> P y)) (fun (Hind:forall (P:(bool.bool -> Prop)), ((le n m) -> P bool.true) -> ((connectives.Not (le n m)) -> P bool.false) -> P (leb n m)) => (fun (P:bool.bool -> Prop) => fun (Pt:(le (S n) (S m)) -> P bool.true) => (fun (Pf:(connectives.Not (le (S n) (S m))) -> P bool.false) => ((((Hind) (P)) (fun (lenm:le n m) => ((Pt) ((((le_S_S) (n)) (m)) (lenm))))) (fun (nlenm:connectives.Not (le n m)) => ((Pf) ((((not_le_to_not_le_S_S) (n)) (m)) (nlenm)))))))))))).
Definition le_to_leb_true : forall (n:nat), forall (m:nat), (le n m) -> logic.eq (bool.bool) (leb n m) bool.true := fun (n:nat) => fun (m:nat) => (((((leb_elim) (n)) (m)) (fun (__:bool.bool) => (le n m) -> logic.eq (bool.bool) __ bool.true)) (fun (auto:le n m) => (fun (auto':le n m) => (((logic.refl) (bool.bool)) (bool.true))))) (fun (H:connectives.Not (le n m)) => (fun (H1:le n m) => (((connectives.falsity) (logic.eq (bool.bool) bool.false bool.true)) ((((logic.absurd) (le n m)) (H1)) (H))))).
Definition not_le_to_leb_false : forall (n:nat), forall (m:nat), (connectives.Not (le n m)) -> logic.eq (bool.bool) (leb n m) bool.false := fun (n:nat) => fun (m:nat) => (((((leb_elim) (n)) (m)) (fun (__:bool.bool) => (connectives.Not (le n m)) -> logic.eq (bool.bool) __ bool.false)) (fun (H:le n m) => (fun (H1:connectives.Not (le n m)) => (((connectives.falsity) (logic.eq (bool.bool) bool.true bool.false)) ((((logic.absurd) (le n m)) (H)) (H1)))))) (fun (auto:connectives.Not (le n m)) => (fun (auto':connectives.Not (le n m)) => (((logic.refl) (bool.bool)) (bool.false)))).
